#include "gestionListeChaineeVMS.h"
#include "gestionVMS.h"
#include "gui.h"
#include "fifo.h"

struct noeud* head;
struct noeud* queue;
int nbVM;
int nbThread;
int nbThreadAELX;
sem_t semH, semQ, semnbVM, semC, semAELX, semNbThread;
int read_res;
pthread_attr_t attr;


int main(int argc, char * args[]) {

    head = NULL;
	queue = NULL;
	nbVM = 0;
    nbThreadAELX = 0;

    int server_fifo_fd, client_fifo_fd;
    char client_fifo[100];

    pthread_t tid[100];

    // Initialize thread attributes
    pthread_attr_init(&attr);

    // Set the thread as detached
    pthread_attr_setdetachstate(&attr, PTHREAD_CREATE_DETACHED); //no need to join threads

    sem_init(&semH, 0, 1);	
	sem_init(&semQ, 0, 1);
	sem_init(&semnbVM, 0, 1);	
	sem_init(&semC, 0, 1);
	sem_init(&semAELX, 0, 1);
    
    //CREER FIFO SERVEUR
    if (mkfifo(NOM_SERVEUR_FIFO ,0777)== -1) { 
        printf("fifo not created\n");
        exit(0);
    }
    printf("Fifo serveur creer\n"); 

    //OPEN FIFO SERVEUR
    server_fifo_fd = open(NOM_SERVEUR_FIFO, O_RDONLY);
    if (server_fifo_fd == -1) {
        printf("Server fifo failure\n");
        exit(0);
    } 
   
   do {
        // READ FIFO SERVEUR
        struct info_FIFO_Transaction * ptr = malloc(sizeof(struct info_FIFO_Transaction));    

        read_res = read(server_fifo_fd, ptr, sizeof(struct info_FIFO_Transaction)); 

        // Create a thread when there is a message to read
        pthread_create(&tid[1], &attr, &readFifoServeur, ptr);

    } while (read_res > 0);

    sem_destroy(&semH);
    sem_destroy(&semQ);
    sem_destroy(&semnbVM);
    sem_destroy(&semC);
    sem_destroy(&semAELX);

    pthread_attr_destroy(&attr);

    close(server_fifo_fd);
    unlink(NOM_SERVEUR_FIFO);

    exit(EXIT_SUCCESS);
}	

void writeFifoClient(struct info_FIFO_Transaction* ptr) {
    char client_fifo[100];
    int client_fifo_fd;

    //OPEN FIFO CLIENT
    sprintf(client_fifo, NOM_CLIENT_FIFO, ptr->pid_client);
    client_fifo_fd = open(client_fifo, O_WRONLY);

    //WRITE FIFO CLIENT
    if (client_fifo_fd != -1) {
        write(client_fifo_fd, ptr, sizeof(struct info_FIFO_Transaction));
        close(client_fifo_fd);
    }
     free(ptr);
}

//affiche client pid et transaction, valider input, et diriger vers la bonne traitement/réponse
void* readFifoServeur(struct info_FIFO_Transaction* ptr) {

    pthread_t th;

    printf("%d: %s\n",ptr->pid_client,ptr->transaction); 
        
    //validation lecture du client
    if (ptr->transaction[0]=='A' || ptr->transaction[0]=='a' ||
            ptr->transaction[0]=='L' || ptr->transaction[0]=='l' ||
            ptr->transaction[0]=='E' || ptr->transaction[0]=='e' ||
            ptr->transaction[0]=='X' || ptr->transaction[0]=='x' ) 
    {
        //créer thread pour executer transaction lié au input client
        pthread_create(&th, &attr, readTrans, ptr);
    }

    //réponse à la connection d'un client
    else if (strcmp(ptr->transaction, "CLIENT EST CONNECTE") == 0)
    {
        strcpy(ptr->transaction, "SERVEUR EST PRET!!!");
        writeFifoClient(ptr);
    }

    //si client envoie autre information
    else 
    {
        strcpy(ptr->transaction, "Serveur ne traite pas votre demande. Veuillez ressayer.");
        writeFifoClient(ptr);
    }
    
    return NULL;
}



