#include <stdio.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/stat.h>
#include <sys/types.h>
#include "client.c"
#include "gestionListeChaineeVMS.h"

#define FIFO_TRANSACTIONS "FIFO_TRANSACTIONS"
#define MAX_BUFFER_SIZE 400

//************************************ Ici je réponds a l'exigeance c) et f) du TP2 ****************************************


int main() {
	    serializeInfoVM(&vm_info, serialized, MAX_BUFFER_SIZE);
    // Envoyer la sérialisation via la FIFO client_fifo_fd
    return 0;
    
    // Crée la FIFO de transmission de transactions
    mkfifo(FIFO_TRANSACTIONS, 0666); // Crée la FIFO avec des autorisations de lecture/écriture
    struct infoVM vm_info = {1, 0, NULL};
    char serialized[MAX_BUFFER_SIZE];
}

    // Ouvrir la FIFO en mode lecture bloquante
    int fd = open(FIFO_TRANSACTIONS, O_RDONLY);

    if (fd == -1) {
        perror("Impossible d'ouvrir la FIFO en lecture");
        return 1;
    }

    // Lecture des données depuis la FIFO (côté serveur) 
    char buffer[BUFSIZ];
    ssize_t bytesRead;

    while (1) {
        // Lire depuis la FIFO
        bytesRead = read(fd, buffer, BUFSIZ);

        if (bytesRead > 0) {
            printf("Données lues depuis la FIFO : %s\n", buffer);
            // Traiter les données lues (opérations sur les VMs, etc.)
        }
    }
    
    //***************************************** Ici je réponds à l'exigeance d) du TP2 ***************************************
    
    struct Info_FIFO_Transaction {
    int pid_client;
    char transaction[200];
};

void* processTransaction(void* arg) {
    struct Info_FIFO_Transaction* transaction = (struct Info_FIFO_Transaction*)arg;

    // Traitement de la transaction
    printf("Transaction du client %d : %s\n", transaction->pid_client, transaction->transaction);

    if (strncmp(transaction->transaction, "A", 1) == 0) {
        // Ajout d'une VM
        // Traiter l'ajout d'une VM
    } else if (strncmp(transaction->transaction, "L", 1) == 0) {
        // Listage des informations d'une VM
        // Traiter le listage des informations d'une VM
    } else if (strncmp(transaction->transaction, "E", 1) == 0) {
        // Suppression d'une VM
        // Traiter la suppression d'une VM
    } else if (strncmp(transaction->transaction, "X", 1) == 0) {
        // Exécution du code binaire
        // Traiter l'exécution du code binaire spécifié
    }
    
 //************************************ Ici je réponds à l'exigeance e) du TP2 ************************************************

// Répondre au client via la FIFO dédiée
    int fifo_transaction_fd, client_fifo_fd;
    char client_fifo[100];

    fifo_transaction_fd = open("./FIFO_TRANSACTIONS", O_RDONLY);
    if (fifo_transaction_fd != -1) {
        // Lecture de la transaction
        read(fifo_transaction_fd, &transaction, sizeof(transaction));
        close(fifo_transaction_fd);

        // Création du nom de la FIFO du client
        sprintf(client_fifo, "FIFO%d", transaction.pid_client);

        // Ouverture et écriture dans la FIFO du client
        client_fifo_fd = open(client_fifo, O_WRONLY);
        if (client_fifo_fd != -1) {
            close(client_fifo_fd);
        } else {
            perror("Erreur lors de l'ouverture de la FIFO du client");
        }
    } else {
        perror("Erreur lors de la lecture de la FIFO de transactions");
    }
}
    free(transaction);
    return NULL;
    
}

void readTrans() {
    int fd = open(FIFO_TRANSACTIONS, O_RDONLY);
    if (fd == -1) {
        perror("Impossible d'ouvrir la FIFO en lecture");
        exit(EXIT_FAILURE);
    }

    struct Info_FIFO_Transaction transaction;

    while (read(fd, &transaction, sizeof(struct Info_FIFO_Transaction)) > 0) {
        // Démarrer un thread pour traiter la transaction
        pthread_t thread;
        struct Info_FIFO_Transaction* transaction_copy = malloc(sizeof(struct Info_FIFO_Transaction));
        memcpy(transaction_copy, &transaction, sizeof(struct Info_FIFO_Transaction));

        if (pthread_create(&thread, NULL, processTransaction, (void*)transaction_copy) != 0) {
            perror("Erreur lors de la création du thread");
            close(fd);
            exit(EXIT_FAILURE);
        }

        // Attendre la fin du thread
        pthread_join(thread, NULL);
    }

    close(fd);
}

    // Fermer la FIFO et terminer le programme
    close(fd);
    unlink(FIFO_TRANSACTIONS); // Supprimer la FIFO
    return 0;
}
