// Here's the client, client.c. The first part of this program opens the server FIFO,
// if it already exists, as a file. It then gets its own process ID, which forms some
// of the data that will be sent to the server. The client FIFO is created, ready for
// the next section.

#include "client.h"
#include "gestionListeChaineeVMS.h"
#include <ctype.h>

int main()
{
    int fifo_transaction_fd, client_fifo_fd;
    struct Info_FIFO_Transaction transaction;    
    char client_fifo[100];   	
    WINDOW *new_window_ptr;
    WINDOW *popup_window_ptr; 
    int x_loop;
    int y_loop;
    char a_letter = '='; 
    int i;

    initscr();   
   
    fifo_transaction_fd = open(FIFO_TRANSACTIONS, O_WRONLY);       
    
    if (fifo_transaction_fd == -1) {
        fprintf(stderr, "Sorry, no server\n");
        exit(EXIT_FAILURE);
    }

    transaction.client_pid = getpid();
    sprintf(client_fifo, CLIENT_FIFO_NAME, transaction.client_pid);

    if (mkfifo(client_fifo, 0777) == -1) {
        fprintf(stderr, "Sorry, can't make %s\n", client_fifo);
        exit(EXIT_FAILURE);
    }
   
    if (!has_colors()) {
        endwin();
        fprintf(stderr, "Error - no color support on this terminal\n");
        exit(1);
    }

    if (start_color() != OK) {
        endwin();
        fprintf(stderr, "Error - could not initialize colors\n");
        exit(2);
    }

 /*  We can now print out the allowed number of colors and color pairs.
    We create seven color pairs and display them one at a time.  */

    clear();

    init_pair(1, COLOR_WHITE, COLOR_BLACK);    
  
    init_pair(3, COLOR_CYAN, COLOR_WHITE);

    attrset(COLOR_PAIR(3));
    
    refresh();
       
    for (x_loop = 0; x_loop < COLS - 1; x_loop++) {
        for (y_loop = 0; y_loop < LINES - 14; y_loop++) {
            mvwaddch(stdscr, y_loop, x_loop, a_letter);            
        }
    }

  
      
    for (x_loop = 0; x_loop < COLS - 1; x_loop++) {
        for(y_loop = 15; y_loop < LINES -1; y_loop++) {
            mvwaddch(stdscr, y_loop, x_loop, a_letter);           
        }
    }

    refresh();
    attrset(COLOR_PAIR(1));
    refresh();

 // For each of the five loops, the client data is sent to the server.
 // Then the client FIFO is opened (read-only, blocking mode) and the data read back.
 // Finally, the server FIFO is closed and the client FIFO removed from memory.

   do{        
        bzero(transaction.some_data, strlen(transaction.some_data));               
      
        /*Then we fill the base window with characters,
        refreshing the actual screen once the logical screen has been filled:*/
        move(5, 5);
       
        new_window_ptr = newwin(10, 120, 2, 2);
        mvwprintw(new_window_ptr, 0, 1, "%s", "*****************************\n");
        mvwprintw(new_window_ptr, 1, 1, "%s", "*         TRANSMISSION      *\n"); 
        mvwprintw(new_window_ptr, 2, 1, "%s", "*****************************\n");
        mvwprintw(new_window_ptr, 4, 2, "%s", "Enter a new transaction or enter 'q' to exit : \n");

        refresh(); 
        wrefresh(new_window_ptr);          
        
        move(7,4);
      
        getstr(transaction.some_data);         
       
        if(transaction.some_data[0] != 'q' && transaction.some_data[0] != 'Q')
        { 
            write(fifo_transaction_fd, &transaction, sizeof(transaction));
            
            client_fifo_fd = open(client_fifo, O_RDONLY);  
            
            if (client_fifo_fd != -1) 
            {
                if (read(client_fifo_fd, &transaction, sizeof(transaction)) > 0) 
                {
                   
                    /*  If we make a call to refresh the new window, nothing will change,
                    because we haven't changed the new window.  */

                    /* But if we touch the window first
                    and trick curses into thinking that the window has been changed.
                    The next call to wrefresh will bring the new window to the front again.  */

                    touchwin(new_window_ptr);
                    wrefresh(new_window_ptr);                    

                    popup_window_ptr = newwin(15, 120, 14, 2);
                  
                    mvwprintw(popup_window_ptr, 0, 1, " ");
                  
                    mvwprintw(popup_window_ptr, 0, 1, "%s", "*****************************\n");
                    mvwprintw(popup_window_ptr, 1, 1, "%s", "*         RECEPTION         *\n"); 
                    mvwprintw(popup_window_ptr, 2, 1, "%s", "*****************************\n");
                    mvwprintw(popup_window_ptr, 4, 2, "%s \n", transaction.some_data);
                    wrefresh(popup_window_ptr);   
                }
                close(client_fifo_fd);
            }
        }            
        
    }
    while(transaction.some_data[0] != 'q' && transaction.some_data[0] != 'Q');
    endwin();
    close(fifo_transaction_fd);
    unlink(client_fifo);

    printf("========EXIT=======\n");
    exit(EXIT_SUCCESS);
}
