#include "gestionListeChaineeVMS.h"
#include "gestionVMS.h"
#include "client.h"
#include <ctype.h>

//Pointeur de tête de liste
extern struct noeud* tete;
//Pointeur de fin de liste pour ajout rapide
extern struct noeud* fin;
// nombre de VM actives
extern int nbVM;
// nombre de threads actifs
extern int nbThreadAELX;
// Semaphore ayant acces a la console et nbThreadALX
extern semC, semnbThreadAELX;
//Et Semaphore sur les pointeurs de char  creer//-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*--*-//
extern sem_t semAdd, semRemove, semList, semExecute;

//Pointeurs qui permeterons d'enregistrer le modif sur l'inerface//-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*--*-//
extern char* zoneMemoireOperationAdd;
extern char* zoneMemoireOperationRemove;
extern char* zoneMemoireOperationList;
extern char* zoneMemoireOperationExecute;





//#######################################
//#
//# Affiche une série de retour de ligne pour "nettoyer" la console
//#
void cls(void){
	printf("\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n");
	}

//#######################################
//#
//# Affiche un messgae et quitte le programme
//#
void error(const int exitcode, const char * message){
	printf("\n-------------------------\n%s\n",message);
	exit(exitcode);
	}
	
/* Sign Extend */
uint16_t sign_extend(uint16_t x, int bit_count)
{
    if ((x >> (bit_count - 1)) & 1) {
        x |= (0xFFFF << bit_count);
    }
    return x;
}

/* Swap */
uint16_t swap16(uint16_t x)
{
    return (x << 8) | (x >> 8);
}

/* Update Flags */
void update_flags(uint16_t reg[R_COUNT], uint16_t r)
{
    if (reg[r] == 0)
    {
        reg[R_COND] = FL_ZRO;
    }
    else if (reg[r] >> 15) /* a 1 in the left-most bit indicates negative */
    {
        reg[R_COND] = FL_NEG;
    }
    else
    {
        reg[R_COND] = FL_POS;
    }
}


/* Validation of an adress generated by a program  */
int validAdress(uint16_t * memory,uint16_t  offset, struct noeudVM * ptr, char accessType)
{
	
	if(((memory+offset) > (memory+65535)) || ((memory) > (memory+offset)) )
	{  
		printf("\n Adresse invalide");
		return 0; 
	}	
    if (accessType == 'W') { // validate if in code region
			if(((memory+offset) > (memory+ptr->VM.offsetDebutCode)) && ((memory+ptr->VM.offsetFinCode) > (memory+offset)))
			{  
				printf("\n Adresse invalide en Write");
				return 0;
			}				
	}		
	return 1;
}

/* Read Image File */
int read_image_file(uint16_t * memory, char* image_path,uint16_t * origin,  struct noeudVM * ptr)
{
	 char fich[200];
	 strcpy(fich,image_path);
  	 FILE* file = fopen(fich, "rb");
 
    if (!file) { return 0; }
    /* the origin tells us where in memory to place the image */
   	*origin=0x3000;

    /* we know the maximum file size so we only need one fread */
    uint16_t max_read = UINT16_MAX - *origin;
    uint16_t* p = memory + *origin;
    ptr->VM.offsetDebutCode = *origin;
    size_t read = fread(p, sizeof(uint16_t), max_read, file);
    ptr->VM.offsetFinCode = *origin+read-1;
    /* swap to little endian ???? */
    while (read-- > 0)
    {
        ++p;
    }
    return 1;
}


/* Check Key */
uint16_t check_key()
{
    fd_set readfds;
    FD_ZERO(&readfds);
    FD_SET(STDIN_FILENO, &readfds);

    struct timeval timeout;
    timeout.tv_sec = 0;
    timeout.tv_usec = 0;
    return select(1, &readfds, NULL, NULL, &timeout) != 0;
}

/* Memory Access */
void mem_write(uint16_t * memory, uint16_t address, uint16_t val)
{
    memory[address] = val;
}

uint16_t mem_read( uint16_t * memory, uint16_t address)
{
    if (address == MR_KBSR)
    {
        if (check_key())
        {
            memory[MR_KBSR] = (1 << 15);
            memory[MR_KBDR] = getchar();
        }
        else
        {
            memory[MR_KBSR] = 0;
        }
    }
    return memory[address];
}

/* Input Buffering */
struct termios original_tio;

void disable_input_buffering()
{
    tcgetattr(STDIN_FILENO, &original_tio);
    struct termios new_tio = original_tio;
    new_tio.c_lflag &= ~ICANON & ~ECHO;
    tcsetattr(STDIN_FILENO, TCSANOW, &new_tio);
}

void restore_input_buffering()
{
    tcsetattr(STDIN_FILENO, TCSANOW, &original_tio);
}

/* Handle Interrupt */
void handle_interrupt(int signal)
{
    restore_input_buffering();
    printf("\n");
    exit(-2);
}


//#######################################
//#
//# Execute le fichier de code .obj 
//#
void executeFile(struct paramX* param){
    //On enregistre les informations de param
	char sourcefname[100]; 
	int noVM;
	noVM = param ->noVM;
	strcpy(sourcefname,(const char*)param->nomfich);
	//on libere le bloc de memoire associe a param
	free(param);
	
	sem_wait(&semnbThreadAELX);
	    nbThreadAELX++;
	sem_post(&semnbThreadAELX);
   
/* Memory Storage */
/* 65536 locations */
	uint16_t *  memory;
	uint16_t origin;
	uint16_t PC_START;
	
/* Register Storage */
	uint16_t reg[R_COUNT];
	
	//Trouver le noeud 
    struct noeudVM * ptr =  findItem(noVM);
    //savoir que dans la version du prof, le noeud qu'on obtient est deja verouille
    //donc il faudra faire un sem_post()apres l'avoir utilise
	
    if(ptr == NULL)
    {
		  sem_wait(&semC);
		  strcpy(zoneMemoireOperationExecute, "\tLa machine virtuelle selectionne n'Est pas dans la liste\n");//-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*--*-//
        //printf("Virtual Machine unavailable\n");
        sem_post(&semC);
        pthread_exit(0);
    }
	
	   	
	memory = ptr->VM.ptrDebutVM;
	
	//si on n'arrive pas a lire le fichier binaire 
    if (!read_image_file(memory, sourcefname, &origin, ptr))
    {
    	//on le note a la console
			sem_wait(&semC);
        //printf("Failed to load image: %s\n", sourcefname);
        sprintf(zoneMemoireOperationExecute,"\tFailed to load image: %s\n", sourcefname); //-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*--*-//
        sem_post(&semC);

        //on libere le noeud(car on on a recu un noeud bloque
        sem_post(&ptr->semVM);
        //Puis on quitte le thread
        pthread_exit(0);
    }
	
	//Verrouiller la console
    sem_wait(&semC);
    
	//on attend que le noeud ne soit pas occupe
    while(ptr->VM.busy != 0){ // wait for the VM 
    }
    
   //Quand on recoit le noeud non occupe, on le set a "occupe" pour pouvoir travailler avec
	// Acquiring access to the VM
    ptr->VM.busy = 1;
    
    /* Setup */
    signal(SIGINT, handle_interrupt);
    disable_input_buffering();

    /* set the PC to starting position */
    /* at  ptr->VM.ptrDebutVM + 0x3000 is the default  */
    //enum { PC_START = origin };
    PC_START = origin;
    reg[R_PC] = PC_START;
    uint16_t instr;
    uint16_t op;

    int running = 1;
    sprintf(zoneMemoireOperationExecute, "\t%s", sourcefname);//-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*--*-//
    while (running)
    {
        /* FETCH */
		if(validAdress(memory, reg[R_PC], ptr, 'R'))
		{
			instr = mem_read(memory, reg[R_PC]++); 
// printf("\n instr = %x", instr);
		
		}
      else //invalid adress
      {
			running = 0;
			//printf("\n Program abort memory problem");
			strcpy(zoneMemoireOperationExecute, "\n Program abort memory problem");//-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*--*-//
			continue;
		}
		op = instr >> 12;
// printf("\n exe op = %x", op);

        switch (op)
        {
            case OP_ADD:
                /* ADD */
                {
                    /* destination register (DR) */
                    uint16_t r0 = (instr >> 9) & 0x7;
                    /* first operand (SR1) */
                    uint16_t r1 = (instr >> 6) & 0x7;
                    /* whether we are in immediate mode */
                    uint16_t imm_flag = (instr >> 5) & 0x1;
                
                    if (imm_flag)
                    {
                        uint16_t imm5 = sign_extend(instr & 0x1F, 5);
                        reg[r0] = reg[r1] + imm5;
                    }
                    else
                    {
                        uint16_t r2 = instr & 0x7;
                        reg[r0] = reg[r1] + reg[r2];
 //printf("\n add reg[r0] (sum) = %d", reg[r0]);
 sprintf(zoneMemoireOperationExecute, "\n add reg[r0] (sum) = %d", reg[r0]);//-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*--*-//
                    }
                
                    update_flags(reg, r0);
                }

                break;
            case OP_AND:
                /* AND */
                {
                    uint16_t r0 = (instr >> 9) & 0x7;
                    uint16_t r1 = (instr >> 6) & 0x7;
                    uint16_t imm_flag = (instr >> 5) & 0x1;
                
                    if (imm_flag)
                    {
                        uint16_t imm5 = sign_extend(instr & 0x1F, 5);
                        reg[r0] = reg[r1] & imm5;
                    }
                    else
                    {
                        uint16_t r2 = instr & 0x7;
                        reg[r0] = reg[r1] & reg[r2];
                    }
                    update_flags(reg, r0);
                }

                break;
            case OP_NOT:
                /* NOT */
                {
                    uint16_t r0 = (instr >> 9) & 0x7;
                    uint16_t r1 = (instr >> 6) & 0x7;
                
                    reg[r0] = ~reg[r1];
                    update_flags(reg, r0);
                }

                break;
            case OP_BR:
                /* BR */
                {
                    uint16_t pc_offset = sign_extend(instr & 0x1FF, 9);
                    uint16_t cond_flag = (instr >> 9) & 0x7;
                    if (cond_flag & reg[R_COND])
                    {
                        reg[R_PC] += pc_offset;
                    }
                }

                break;
            case OP_JMP:
                /* JMP */
                {
                    /* Also handles RET */
                    uint16_t r1 = (instr >> 6) & 0x7;
                    reg[R_PC] = reg[r1];
                }

                break;
            case OP_JSR:
                /* JSR */
                {
                    uint16_t long_flag = (instr >> 11) & 1;
                    reg[R_R7] = reg[R_PC];
                    if (long_flag)
                    {
                        uint16_t long_pc_offset = sign_extend(instr & 0x7FF, 11);
                        reg[R_PC] += long_pc_offset;  /* JSR */
                    }
                    else
                    {
                        uint16_t r1 = (instr >> 6) & 0x7;
                        reg[R_PC] = reg[r1]; /* JSRR */
                    }
                    break;
                }

                break;
            case OP_LD:
                /* LD */
           {
                    uint16_t r0 = (instr >> 9) & 0x7;
                    uint16_t pc_offset = sign_extend(instr & 0x1FF, 9);
					if(validAdress(memory, reg[R_PC]+ pc_offset, ptr, 'R'))
					{
						reg[r0] = mem_read(memory, reg[R_PC] + pc_offset); // valider adresse afficher message erreur mem et running = 0
						update_flags(reg, r0);
					}
					else //invalid adress
					{
						running = 0;
						//printf("\n Program abort memory out of bound");
						strcpy(zoneMemoireOperationExecute, "\n Program abort memory out of bound");//-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*--*-//
					}
           }

                break;
            case OP_LDI:
                /* LDI */
            {
                    /* destination register (DR) */
                    uint16_t r0 = (instr >> 9) & 0x7;
                    /* PCoffset 9*/
                    uint16_t pc_offset = sign_extend(instr & 0x1FF, 9);
                    /* add pc_offset to the current PC, look at that memory location to get the final address */
					if(validAdress(memory, reg[R_PC]+ pc_offset, ptr, 'R'))
					{
						reg[r0] = mem_read(memory, mem_read(memory, reg[R_PC] + pc_offset)); // valider adresse afficher message erreur mem et running = 0
						update_flags(reg, r0);
					}
					else //invalid adress
					{
						running = 0;
						//printf("\n Program abort memory out of bound");
						strcpy(zoneMemoireOperationExecute, "\n Program abort memory out of bound");//-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*--*-//
					}
            }

                break;
            case OP_LDR:
                /* LDR */
            {
                    uint16_t r0 = (instr >> 9) & 0x7;
                    uint16_t r1 = (instr >> 6) & 0x7;
                    uint16_t offset = sign_extend(instr & 0x3F, 6);
					if(validAdress(memory, reg[r1]+ offset, ptr, 'R'))
					{
						reg[r0] = mem_read(memory, reg[r1] + offset); // valider adresse afficher message erreur mem et running = 0
						update_flags(reg, r0);
					}
					else //invalid adress
					{
						running = 0;
						//printf("\n Program abort memory out of bound");
						strcpy(zoneMemoireOperationExecute, "\n Program abort memory out of bound");//-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*--*-//
					}
           }

                break;
            case OP_LEA:
                /* LEA */
                {
                    uint16_t r0 = (instr >> 9) & 0x7;
                    uint16_t pc_offset = sign_extend(instr & 0x1FF, 9);
                    reg[r0] = reg[R_PC] + pc_offset;
                    update_flags(reg, r0);
                }

                break;
            case OP_ST:
                /* ST */
            {
                    uint16_t r0 = (instr >> 9) & 0x7;
                    uint16_t pc_offset = sign_extend(instr & 0x1FF, 9);
					if(validAdress(memory, reg[R_PC]+ pc_offset, ptr, 'W'))
					{
						mem_write(memory, reg[R_PC] + pc_offset, reg[r0]); // valider adresse afficher message erreur mem et running = 0
					}
					else //invalid adress
					{
						running = 0;
						strcpy(zoneMemoireOperationExecute, "\n Program abort memory out of bound or access violation");//-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*--*-//
						//printf("\n Program abort memory out of bound or access violation");
					}                
				}

                break;
            case OP_STI:
                /* STI */
            {
                    uint16_t r0 = (instr >> 9) & 0x7;
                    uint16_t pc_offset = sign_extend(instr & 0x1FF, 9);
					if(validAdress(memory, reg[R_PC] + pc_offset, ptr, 'R'))
					{
						if(validAdress(memory, mem_read(memory, reg[R_PC] + pc_offset), ptr, 'W'))
						{
							mem_write(memory, mem_read(memory, reg[R_PC] + pc_offset), reg[r0]); // valider adresse afficher message erreur mem et running = 0
						}
						else //invalid adress
						{
							running = 0;
							//printf("\n Program abort memory out of bound or access violation");
					strcpy(zoneMemoireOperationExecute, "\n Program abort memory out of bound or access violation");//-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*--*-//
						}
					}
					else //invalid adress
					{
						running = 0;
						//printf("\n Program abort memory out of bound");
						strcpy(zoneMemoireOperationExecute, "\n Program abort memory out of bound");//-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*--*-//
					}						
				}

                break;
            case OP_STR:
                /* STR */
            {
                    uint16_t r0 = (instr >> 9) & 0x7;
                    uint16_t r1 = (instr >> 6) & 0x7;
                    uint16_t offset = sign_extend(instr & 0x3F, 6);
					if(validAdress(memory, reg[r1] + offset, ptr, 'W'))
					{
						mem_write(memory, reg[r1] + offset, reg[r0]); // valider adresse afficher message erreur mem et running = 0
 					}
					else //invalid adress
					{
						running = 0;
						//printf("\n Program abort memory out of bound or access violation");
						strcpy(zoneMemoireOperationExecute, "\n Program abort memory out of bound or access violation");//-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*--*-//
					}                                
				}

                break;
            case OP_TRAP:
                /* TRAP */
                switch (instr & 0xFF)
                {
                    case TRAP_GETC:
                        /* TRAP GETC */
                        /* read a single ASCII char */
                        reg[R_R0] = (uint16_t)getchar();

                        break;
                    case TRAP_OUT:
                        /* TRAP OUT */
                        putc((char)reg[R_R0], stdout);
                        fflush(stdout);

                        break;
                    case TRAP_PUTS:
                        /* TRAP PUTS */
                    {
                            /* one char per word */
                            uint16_t* c = memory + reg[R_R0]; // valider adresse afficher message erreur mem et running = 0
							if(validAdress(c, 0, ptr, 'R'))
							{
								while (*c)
								{
									putc((char)*c, stdout);
									++c; // valider adresse afficher message erreur mem et running = 0
									if(!validAdress(c, 0, ptr, 'R'))
									{
										running = 0;
										//printf("\n Program abort memory out of bound");
										strcpy(zoneMemoireOperationExecute, "\n Program abort memory out of bound");//-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*--*-//
										*c = 0;
									}     
								}
								fflush(stdout);
							}
							else //invalid adress
							{
								running = 0;
								//printf("\n Program abort memory out of bound");
strcpy(zoneMemoireOperationExecute, "\n Program abort memory out of bound");//-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*--*-//
							}     
                   }

                        break;
                    case TRAP_IN:
                        /* TRAP IN */
                        {
                            //printf("Enter a character: ");
                            strcpy(zoneMemoireOperationExecute, "Enter a character: ");//-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*--*-//
                            char c = getchar();
                            putc(c, stdout);
                            reg[R_R0] = (uint16_t)c;
                        }

                        break;
                    case TRAP_PUTSP:
                        /* TRAP PUTSP */
                    {
                            /* one char per byte (two bytes per word)
                               here we need to swap back to
                               big endian format */
                            uint16_t* c = memory + reg[R_R0]; // valider adresse afficher message erreur mem et running = 0
							if(validAdress(c, 0, ptr, 'R'))
							{
								while (*c)
								{
									char char1 = (*c) & 0xFF;
									putc(char1, stdout);
									char char2 = (*c) >> 8;
									/*
									char char1 = (*c) >> 8;
									putc(char1, stdout);
									char char2 = (*c) & 0xFF;
									*/
									if (char2) putc(char2, stdout);
									++c; // valider adresse afficher message erreur mem et running = 0
									if(!validAdress(c, 0, ptr, 'R'))
									{
										running = 0;
										//printf("\n Program abort memory out of bound");
										strcpy(zoneMemoireOperationExecute, "\n Program abort memory out of bound");//-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*--*-//
										*c = 0;
									}     
								}
								fflush(stdout);
							}
							else //invalid adress
							{
								running = 0;
								//printf("\n Program abort memory out of bound");
								strcpy(zoneMemoireOperationExecute, "\n Program abort memory out of bound");//-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*--*-//
							}     
                   }

                        break;
                    case TRAP_HALT:
                        /* TRAP HALT */
                        puts("\n HALT");
                        fflush(stdout);
                        running = 0;

                        break;
                }

                break;
            case OP_RES:
            case OP_RTI:
            default:
                /* BAD OPCODE */
                abort();

                break;
        }
    }
    
    
    //A la fin de l'utilisation du noeud, on le libere (setter a "disponible")
    ptr->VM.busy = 0;
    
    /* Shutdown */
    restore_input_buffering();
    
    //on libere le noeud quand on a fini de l'utiliser
	 sem_post(&ptr->semVM);    
    
    //liberer la console
    sem_post(&semC);
    
    sem_wait(&semnbThreadAELX);
	    nbThreadAELX--;
	sem_post(&semnbThreadAELX);
	
    pthread_exit(NULL);
}


//#######################################
//#
//# fonction utilisée pour le traitement  des transactions
//# ENTREE: Nom de fichier de transactions 
//# SORTIE: 
void* readTrans(char* nomFichier){
	FILE *f;
	char buffer[100];
	char *tok, *sp;
	//une liste de thread
	pthread_t tid[1000];
	//un compteur de thread(nbtread) et un variable qui sert d'index a la liste(i)
	int i, nbTread =0;

	//Notons qu'on ne lis plus de fichier, mais qu'on accede maintenant a une fifo============================================================================
	/*//Ouverture du fichier en mode "r" (equiv. "rt") : [r]ead [t]ext
	f = fopen(nomFichier, "rt");
	if (f==NULL){
		error(2, "readTrans: Erreur lors de l'ouverture du fichier. \n Essayez un autre fichier en argument \n l'argument s'insere sous forme de=> ./EXECUTABLE ARG[]");
	}
	//Lecture (tentative) d'une ligne de texte
	fgets(buffer, 100, f);*/ //===============================================================================================================================

	 //Info des fifo qui sont dans le teteer de Client.h //*-*-*-*-*-*-*-*-*-*-*-*-**-*-
	 int fifo_transaction_fd, client_fifo_fd;
    struct Info_FIFO_Transaction transaction;//Structure qui va permetre de retourner de l'info a client_Fifo
    int read_res;//Resultat du read(valeur)
    char client_fifo[256];   

	 //Creer la fifo //*-*-*-*-*-*-*-*-*-*-*-*-**-*-
    mkfifo(FIFO_TRANSACTIONS, 0777);
    
    fifo_transaction_fd = open(FIFO_TRANSACTIONS, O_RDONLY);
    //Verifier si le serveur existe //*-*-*-*-*-*-*-*-*-*-*-*-**-*-
    if (fifo_transaction_fd == -1) {
        fprintf(stderr, "\tServer fifo failure\n");
        exit(EXIT_FAILURE);//Si le serveur n'existe pas on quite le prog
    }
	
    sleep(5);

	do {
        read_res = read(fifo_transaction_fd, &transaction, sizeof(transaction));
        if (read_res > 0) 
         { 
      //Branchement selon le type de transaction
		switch(transaction.transaction[0]){
			case 'A':
			case 'a':{
				//Lancer l'ajout d'une vm de maniere concurente
				sem_wait(&semAdd);
            zoneMemoireOperationAdd = transaction.transaction;
				pthread_create(&tid[nbTread++], NULL, addItem, NULL);
				sleep(0.7);//On met en pause, le temps que le thread cree une reponse et l'affiche
				break;
				}
			case 'E':
			case 'e':{
				//creer la structure a passer en argument
				struct Struct_REMOVE *ptr = (struct Struct_REMOVE*) malloc(sizeof(struct Struct_REMOVE));
				sem_wait(&semRemove);
            zoneMemoireOperationRemove = transaction.transaction; 
				//inserer les informations dans la structure 
				ptr->noVM = extract(transaction.transaction);
				//creer le thread de suppression de VM et 
				//lui passer le pointeur vers la structure contenant 
				//les info de la VM a supprimer en argument
				pthread_create(&tid[nbTread++], NULL, removeItem, ptr);
				sleep(0.5);
				break;
				}
			case 'L':
			case 'l':{
				//creer la structure a passer en argument
				struct Struct_Listage *ptr = (struct Struct_Listage*) malloc(sizeof(struct Struct_Listage));
				//inserer les informations dans la structure 
				sem_wait(&semList);
            zoneMemoireOperationList = transaction.transaction; 
				ptr->start = extract(transaction.transaction);
				ptr->end = extract(transaction.transaction);	
			  //	sem_wait(&semList);
           // zoneMemoireOperationList = transaction.transaction; 
				//Creer un thread qui fait le listage des info des vm, et lui passer en arg, la struct
				pthread_create(&tid[nbTread++], NULL, listItems, ptr);		
            sleep(05);		
				break;
				}
			case 'X':
			case 'x':{
				int i = 4;
            int j = 0;
            transaction.transaction[0] = ' ';				
				    refresh();
    attrset(COLOR_PAIR(1));
    refresh();

//Etape 6 - Gerer les transactions 
   do{        
        bzero(transaction.transaction, strlen(transaction.transaction));               
      
        move(5, 5);
       
        new_window_ptr = newwin(10, 120, 2, 2);
        mvwprintw(new_window_ptr, 0, 1, "%s", "=====================================================================\n");
        mvwprintw(new_window_ptr, 1, 1, "%s", "                              TRANSMISSION                           \n"); 
        mvwprintw(new_window_ptr, 2, 1, "%s", "=====================================================================\n");
        mvwprintw(new_window_ptr, 4, 2, 
				//creer la structure a passer en argument
				struct paramX *ptr = (struct paramX*) malloc(sizeof(struct paramX));
				
				sem_wait(&semExecute);
            zoneMemoireOperationExecute= transaction.transaction;                    
            ptr->noVM = extract(transaction.transaction);
                   
            while (transaction.transaction[i] != '\0')
            {
                 ptr->nomfich[j++] = transaction.transaction[i++];
            }  
            
				//Creer un thread qui execute le fichier de code 
				//binaire (nomFichier) sur la vm qu'on lui specifie en arg(noVM)
				pthread_create(&tid[nbTread++], NULL, executeFile, ptr);
				sleep(2);
				break;
				}
				default:
                    sprintf(transaction.transaction, "  ==========  Invalid transaction ==========") ;
		}//fin du swithc/case
		
				sprintf(client_fifo, CLIENT_FIFO_NAME, transaction.pid_client);

            // Then we send the processed data back, opening the client pipe in write-only, blocking mode.
            client_fifo_fd = open(client_fifo, O_WRONLY);
        
            if (client_fifo_fd != -1) {
                write(client_fifo_fd, &transaction, sizeof(transaction));               
                close(client_fifo_fd);
            }  
            sem_post(&semAdd);
            sem_post(&semRemove);
            sem_post(&semList); 
            sem_post(&semExecute);  
		} 
		} while (read_res > 0);
	//S'assurer d'attendre que tous les threads soient fini
	//car si le main fini, les threads vont mourir
	for(i=0; i<nbTread;i++) {
		pthread_join(tid[i], NULL);
	}
	close(fifo_transaction_fd);
    unlink(FIFO_TRANSACTIONS);
    exit(EXIT_SUCCESS);	 
	//Retour
	return NULL;
}
int extract(char *ptr)
{
    int param = 0;
    int i = 1;   
    char listeChiffres [] = "123456789";
    char answer[]="0";
      
    while( i < strlen(ptr) && param == 0  )
    {  
        for (int j = 0; j < sizeof(listeChiffres)-1; j++)
        {
            if(ptr[i] == listeChiffres[j])
            {                                
                answer[0] = listeChiffres[j];
                param = atoi(answer);                               
                ptr[i] = ' ';    
                break;                
            }              
        }             
        i++; 
    }

    return param;  
                    
}
