#include "client.h" // Inclure le fichier d'en-tête client
#include "gestionListeChaineeVMS.h" // Inclure le fichier d'en-tête pour la gestion des listes chaînées des machines virtuelles
#include <ctype.h>

int main() {
    int fifo_transaction_fd, client_fifo_fd;
    struct Info_FIFO_Transaction transaction;
    char client_fifo[100];
    WINDOW *new_window_ptr;
    WINDOW *popup_window_ptr;
    int x_loop;
    int y_loop;
    char a_letter = '*';
    int i;

    initscr();

    fifo_transaction_fd = open(FIFO_TRANSACTIONS, O_WRONLY);

    // Vérifier la présence du serveur
    if (fifo_transaction_fd == -1) {
        fprintf(stderr, "Erreur - Aucun serveur n'a été trouvé \n");
        exit(EXIT_FAILURE);
        // Quitter le programme client.c si le serveur est introuvable ou s'il y a une erreur
    }

    // Envoyer le PID du client dans le nom de la fifo qui sera créée
    transaction.pid_client = getpid(); // Récupérer le PID
    sprintf(client_fifo, CLIENT_FIFO_NAME, transaction.pid_client);


    if (mkfifo(client_fifo, 0777) == -1) {
        fprintf(stderr, "Sorry, can't make %s\n", client_fifo);
        exit(EXIT_FAILURE);
    }


    if (!has_colors()) { // Initialiser la table de couleurs
        endwin();
        fprintf(stderr, "Erreur - Ce terminal ne supporte pas la couleur \n");
        exit(1);
    }

    if (start_color() != OK) {
        endwin();
        fprintf(stderr, "Erreur lors de l'initialisation des couleurs sur le terminal \n");
        exit(2);
    }

    // Création des fenêtres
    clear();
    // Initialiser les paires de couleurs
    init_pair(1, COLOR_WHITE, COLOR_BLACK); // L'entrée 1 sera blanc sur noir
    init_pair(3, COLOR_RED, COLOR_GREEN); // L'entrée 3 sera rouge sur vert
    attrset(COLOR_PAIR(3));
    refresh();

    // Dessiner les lignes pour les fenêtres
    for (x_loop = 0; x_loop < COLS - 1; x_loop++) {
        for (y_loop = 0; y_loop < LINES - 14; y_loop++) {
            mvwaddch(stdscr, y_loop, x_loop, a_letter);
        }
    }

    for (x_loop = 0; x_loop < COLS - 1; x_loop++) {
        for(y_loop = 15; y_loop < LINES -1; y_loop++) {
            mvwaddch(stdscr, y_loop, x_loop, a_letter);
        }
    }

    refresh();
    attrset(COLOR_PAIR(1));
    refresh();

    // Gérer les transactions
    do {
        bzero(transaction.transaction, strlen(transaction.transaction));
        move(5, 5);

        new_window_ptr = newwin(10, 120, 2, 2);
        mvwprintw(new_window_ptr, 0, 1, "%s", "************************************************************\n");
        mvwprintw(new_window_ptr, 1, 1, "%s", "                            TRANSMISSION                    \n");
        mvwprintw(new_window_ptr, 2, 1, "%s", "************************************************************\n");

        mvwprintw(new_window_ptr, 4, 2, "%s", "Saisissez une nouvelle transaction ou 'q'/'quit' pour quitter :\n");


        refresh();
        wrefresh(new_window_ptr);

        move(7,4);

        getstr(transaction.transaction); // Récupérer l'input de l'utilisateur et l'enregistrer dans le paramètre de la struct, soit [transaction.transaction]

        if(transaction.transaction[0] != 'q' && transaction.transaction[0] != 'Q') { // Si l'utilisateur ne quitte pas (envoi d'une transaction)
            write(fifo_transaction_fd, &transaction, sizeof(transaction));

            client_fifo_fd = open(client_fifo, O_RDONLY);

            if (client_fifo_fd != -1) { // Si l'ouverture de la fifo a été un succès
                if (read(client_fifo_fd, &transaction, sizeof(transaction)) > 0) { // Si on a bien reçu la réponse du serveur, on l'affiche

                    touchwin(new_window_ptr);
                    wrefresh(new_window_ptr);

                    popup_window_ptr = newwin(15, 120, 14, 2);

                    mvwprintw(popup_window_ptr, 0, 1, " ");

                    mvwprintw(popup_window_ptr, 0, 1, "%s", "--------------------------------------------------------------\n");
                    mvwprintw(popup_window_ptr, 1, 1, "%s", "|                              RECEPTION                      |        \n");
                    mvwprintw(popup_window_ptr, 2, 1, "%s", "--------------------------------------------------------------\n");
                    mvwprintw(popup_window_ptr, 4, 2, "%s \n", transaction.transaction);
                    wrefresh(popup_window_ptr);
                }
                close(client_fifo_fd); // Fermeture de la fifo de la réception après avoir traité son contenu
            }
        }

    } while(transaction.transaction[0] != 'q' && transaction.transaction[0] != 'Q');

    endwin();
    close(fifo_transaction_fd);
    unlink(client_fifo); // Désactiver la fifo et la supprimer du répertoire

    printf("=====================     Fermeture du Client     =====================\n");
    exit(EXIT_SUCCESS);
}

