#include "gestionListeChaineeVMS.h"
#include "gestionVMS.h"
#include "client.h"
#include <ctype.h>


extern struct noeud* head;// Pointeur vers la tête d'une structure de données de type noeud

extern struct noeud* queue;
extern int nbVM;

extern int nbThreadAELX;

extern semC, semnbThreadAELX;

extern sem_t semAdd, semRemove, semList, semExecute;


extern char* OperationAdd;
extern char* OperationRemove;
extern char* OperationList;
extern char* OperationExecute;





void cls(void){
	printf("\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n");
	}


void error(const int exitcode, const char * message){
	printf("\n-------------------------\n%s\n",message);
	exit(exitcode);
	}

/* Sign Extend */
uint16_t sign_extend(uint16_t x, int bit_count)
{
    if ((x >> (bit_count - 1)) & 1) {
        x |= (0xFFFF << bit_count);
    }
    return x;
}

/* Swap */
uint16_t swap16(uint16_t x)
{
    return (x << 8) | (x >> 8);
}

/* Update Flags */
void update_flags(uint16_t reg[R_COUNT], uint16_t r)
{
    if (reg[r] == 0)
    {
        reg[R_COND] = FL_ZRO;
    }
    else if (reg[r] >> 15) /* a 1 in the left-most bit indicates negative */
    {
        reg[R_COND] = FL_NEG;
    }
    else
    {
        reg[R_COND] = FL_POS;
    }
}


/*On va checker si ladresse se situe dans une plage spécifique avant dafficher les messages dependamment des cas.*/
int validAdress(uint16_t * memory,uint16_t  offset, struct noeudVM * ptr, char accessType)
{

	if(((memory+offset) > (memory+65535)) || ((memory) > (memory+offset)) )
	{
		printf("\n Adresse entrer invalide");
		return 0;
	}
    if (accessType == 'W') {
			if(((memory+offset) > (memory+ptr->VM.offsetDebutCode)) && ((memory+ptr->VM.offsetFinCode) > (memory+offset)))
			{
				printf("\n Adresse invalide en ecriture");
				return 0;
			}
	}
	return 1;
}

//Lecture du contenu d'un fichier bianaire
int read_image_file(uint16_t * memory, char* image_path,uint16_t * origin,  struct noeudVM * ptr)
{
	 char fich[200];
	 strcpy(fich,image_path);
  	 FILE* file = fopen(fich, "rb"); //Ouverture fichier binaire

    if (!file) { return 0; }

   	*origin=0x3000; //initialisation de l'origine avec cette valeur


    uint16_t max_read = UINT16_MAX - *origin;
    uint16_t* p = memory + *origin;
    ptr->VM.offsetDebutCode = *origin;
    size_t read = fread(p, sizeof(uint16_t), max_read, file); //lecture du contenu du fichier
    ptr->VM.offsetFinCode = *origin+read-1;

    while (read-- > 0)
    {
        ++p;
    }
    return 1;
}


//Fonction pour vérifier si une touche a été enfoncée sans bloquer le programme en attendant lentree
uint16_t check_key()
{
    fd_set readfds;
    FD_ZERO(&readfds);
    FD_SET(STDIN_FILENO, &readfds);

    struct timeval timeout;
    timeout.tv_sec = 0;
    timeout.tv_usec = 0;
    return select(1, &readfds, NULL, NULL, &timeout) != 0;
}

//Fonction qui permet decrire une valeur à une adresse spécifiée dans un tableau de mémoire de 16 bits
void mem_write(uint16_t * memory, uint16_t address, uint16_t val)
{
    memory[address] = val;
}

//Lecture d'une valeur à partir d'une adresse spécifiée dans un tableau de mémoire de 16 bits.
uint16_t mem_read( uint16_t * memory, uint16_t address)
{
    if (address == MR_KBSR)
    {
        if (check_key())
        {
            memory[MR_KBSR] = (1 << 15);
            memory[MR_KBDR] = getchar();
        }
        else
        {
            memory[MR_KBSR] = 0;
        }
    }
    return memory[address];
}


struct termios original_tio;

//désactiver la mise en tampon de l'entrée
void disable_input_buffering()
{
    tcgetattr(STDIN_FILENO, &original_tio);
    struct termios new_tio = original_tio;
    new_tio.c_lflag &= ~ICANON & ~ECHO;
    tcsetattr(STDIN_FILENO, TCSANOW, &new_tio);
}

/*restaurer les paramètres d'entrée d'origine du terminal*/
void restore_input_buffering()
{
    tcsetattr(STDIN_FILENO, TCSANOW, &original_tio);
}

//gestionnaire de signal qui est appelée en réponse à une interruption du programme
void handle_interrupt(int signal)
{
    restore_input_buffering();
    printf("\n");
    exit(-2);
}



void executeFile(struct paramX* param){
     // Sauvegarde des informations de param
	char sourcefname[100];
	int noVM;
	noVM = param ->noVM;
	strcpy(sourcefname,(const char*)param->nomfich);
	// Libération du bloc de mémoire associé à param
	free(param);

	sem_wait(&semnbThreadAELX);
	    nbThreadAELX++;
	sem_post(&semnbThreadAELX);

 /* Mémoire */
    /* 65536 emplacements */
	uint16_t *  memory;
	uint16_t origin;
	uint16_t PC_START;


	uint16_t reg[R_COUNT];

// Recherche du nœud
    struct noeudVM * ptr =  findItem(noVM);


    if(ptr == NULL)
    {
		  sem_wait(&semC);
		  strcpy(OperationExecute, "\tLa machine virtuelle que vous avez selectionner n'est pas dans la liste\n");
        sem_post(&semC);
        pthread_exit(0);
    }


	memory = ptr->VM.ptrDebutVM;

	// Si nous ne parvenons pas à lire le fichier binaire
    if (!read_image_file(memory, sourcefname, &origin, ptr))
    {

			sem_wait(&semC);

        sprintf(OperationExecute,"\tFailed to load image: %s\n", sourcefname);
        sem_post(&semC);

        sem_post(&ptr->semVM);

        pthread_exit(0);
    }


    sem_wait(&semC);


    while(ptr->VM.busy != 0){
    }



    ptr->VM.busy = 1;


    signal(SIGINT, handle_interrupt);
    disable_input_buffering();


    PC_START = origin;
    reg[R_PC] = PC_START;
    uint16_t instr;
    uint16_t op;

    int running = 1;
    sprintf(OperationExecute, "\t%s", sourcefname);
    while (running)
    { /*implémentation simplifiée d'une machine virtuelle prenant en charge un ensemble limité d'instructions.*/

		if(validAdress(memory, reg[R_PC], ptr, 'R'))
		{
			instr = mem_read(memory, reg[R_PC]++);


		}
      else
      {
			running = 0;

			strcpy(OperationExecute, "\n Program abort memory problem");
			continue;
		}
		op = instr >> 12;


        switch (op)
        {
            case OP_ADD: /*addition entre deux registres ou un registre et une valeur immédiate.*/

                {
                    uint16_t r0 = (instr >> 9) & 0x7;

                    uint16_t r1 = (instr >> 6) & 0x7;

                    uint16_t imm_flag = (instr >> 5) & 0x1;

                    if (imm_flag)
                    {
                        uint16_t imm5 = sign_extend(instr & 0x1F, 5);
                        reg[r0] = reg[r1] + imm5;
                    }
                    else
                    {
                        uint16_t r2 = instr & 0x7;
                        reg[r0] = reg[r1] + reg[r2];

 sprintf(OperationExecute, "\n add reg[r0] (sum) = %d", reg[r0]);
                    }

                    update_flags(reg, r0);
                }

                break;
            case OP_AND:/*opération logique "ET" entre deux registres ou un registre et une valeur immédiate.*/

                {
                    uint16_t r0 = (instr >> 9) & 0x7;
                    uint16_t r1 = (instr >> 6) & 0x7;
                    uint16_t imm_flag = (instr >> 5) & 0x1;

                    if (imm_flag)
                    {
                        uint16_t imm5 = sign_extend(instr & 0x1F, 5);
                        reg[r0] = reg[r1] & imm5;
                    }
                    else
                    {
                        uint16_t r2 = instr & 0x7;
                        reg[r0] = reg[r1] & reg[r2];
                    }
                    update_flags(reg, r0);
                }

                break;
            case OP_NOT: /*opération logique "NON" sur un registre*/

                {
                    uint16_t r0 = (instr >> 9) & 0x7;
                    uint16_t r1 = (instr >> 6) & 0x7;

                    reg[r0] = ~reg[r1];
                    update_flags(reg, r0);
                }

                break;
            case OP_BR: /*Instruction de branchement pour effectuer un branchement conditionnel en fonction de drapeaux spécifiques*/

                {
                    uint16_t pc_offset = sign_extend(instr & 0x1FF, 9);
                    uint16_t cond_flag = (instr >> 9) & 0x7;
                    if (cond_flag & reg[R_COND])
                    {
                        reg[R_PC] += pc_offset;
                    }
                }

                break;
            case OP_JMP:
                /* JMP */
                {
                    /* Also handles RET */
                    uint16_t r1 = (instr >> 6) & 0x7;
                    reg[R_PC] = reg[r1];
                }

                break;
            case OP_JSR:
                /* JSR */
                {
                    uint16_t long_flag = (instr >> 11) & 1;
                    reg[R_R7] = reg[R_PC];
                    if (long_flag)
                    {
                        uint16_t long_pc_offset = sign_extend(instr & 0x7FF, 11);
                        reg[R_PC] += long_pc_offset;  /* JSR */
                    }
                    else
                    {
                        uint16_t r1 = (instr >> 6) & 0x7;
                        reg[R_PC] = reg[r1]; /* JSRR */
                    }
                    break;
                }

                  break;
            case OP_LD:
                /* LD */
           {
                    uint16_t r0 = (instr >> 9) & 0x7;
                    uint16_t pc_offset = sign_extend(instr & 0x1FF, 9);
					if(validAdress(memory, reg[R_PC]+ pc_offset, ptr, 'R'))
					{
						reg[r0] = mem_read(memory, reg[R_PC] + pc_offset);
						update_flags(reg, r0);
					}
					else //invalid adress
					{
						running = 0;

						strcpy(
                            OperationExecute, "\n Program abort memory out of bound");
					}
           }

                break;
            case OP_LDI: // charge la valeur contenue à l'adresse indiquée par une autre adresse
                /* LDI */
            {

                    uint16_t r0 = (instr >> 9) & 0x7;
                    /* PCoffset 9*/
                    uint16_t pc_offset = sign_extend(instr & 0x1FF, 9);

					if(validAdress(memory, reg[R_PC]+ pc_offset, ptr, 'R'))
					{
						reg[r0] = mem_read(memory, mem_read(memory, reg[R_PC] + pc_offset));
						update_flags(reg, r0);
					}
					else //invalid adress
					{
						running = 0;

						strcpy(OperationExecute, "\n Program abort memory out of bound");
					}
            }

                break;
            case OP_LDR: //charge une valeur depuis la mémoire à l'adresse calculée en ajoutant un décalage à la valeur contenue dans un registre.
                /* LDR */
            {
                    uint16_t r0 = (instr >> 9) & 0x7;
                    uint16_t r1 = (instr >> 6) & 0x7;
                    uint16_t offset = sign_extend(instr & 0x3F, 6);
					if(validAdress(memory, reg[r1]+ offset, ptr, 'R'))
					{
						reg[r0] = mem_read(memory, reg[r1] + offset);
						update_flags(reg, r0);
					}
					else
					{
						running = 0;

						strcpy(OperationExecute, "\n Program abort memory out of bound");
					}
           }

                break;
            case OP_LEA: //charge une adresse de mémoire calculée à partir du compteur de programme
                /* LEA */
                {
                    uint16_t r0 = (instr >> 9) & 0x7;
                    uint16_t pc_offset = sign_extend(instr & 0x1FF, 9);
                    reg[r0] = reg[R_PC] + pc_offset;
                    update_flags(reg, r0);
                }

                break;
            /*Instructions stockage*/
            case OP_ST: //stocke la valeur d'un registre à l'adresse calculée à partir du compteur de programme
                /* ST */
            {
                    uint16_t r0 = (instr >> 9) & 0x7;
                    uint16_t pc_offset = sign_extend(instr & 0x1FF, 9);
					if(validAdress(memory, reg[R_PC]+ pc_offset, ptr, 'W'))
					{
						mem_write(memory, reg[R_PC] + pc_offset, reg[r0]);
					}
					else //invalid adress
					{
						running = 0;
						strcpy(OperationExecute, "\n Program abort memory out of bound or access violation");

					}
				}

                break;
            case OP_STI: //stocke la valeur d'un registre à l'adresse indiquée par une autre adresse.
                /* STI */
            {
                    uint16_t r0 = (instr >> 9) & 0x7;
                    uint16_t pc_offset = sign_extend(instr & 0x1FF, 9);
					if(validAdress(memory, reg[R_PC] + pc_offset, ptr, 'R'))
					{
						if(validAdress(memory, mem_read(memory, reg[R_PC] + pc_offset), ptr, 'W'))
						{
							mem_write(memory, mem_read(memory, reg[R_PC] + pc_offset), reg[r0]);
						}
						else
						{
							running = 0;

					strcpy(OperationExecute, "\n Program abort memory out of bound or access violation");
						}
					}
					else
					{
						running = 0;

						strcpy(OperationExecute, "\n Program abort memory out of bound");
					}
				}

                break;
            case OP_STR: //stocke la valeur d'un registre à l'adresse calculée en ajoutant un décalage à la valeur contenue dans un registre.
                /* STR */
            {
                    uint16_t r0 = (instr >> 9) & 0x7;
                    uint16_t r1 = (instr >> 6) & 0x7;
                    uint16_t offset = sign_extend(instr & 0x3F, 6);
					if(validAdress(memory, reg[r1] + offset, ptr, 'W'))
					{
						mem_write(memory, reg[r1] + offset, reg[r0]);
 					}
					else //invalid adress
					{
						running = 0;

						strcpy(OperationExecute, "\n Program abort memory out of bound or access violation");
					}
				}

                break;
            case OP_TRAP: //effectue des opérations spéciales telles que l'entrée et sortie.
                /* TRAP */
                switch (instr & 0xFF)
                {
                    case TRAP_GETC:
                        /* TRAP GETC */
                        /* read a single ASCII char */
                        reg[R_R0] = (uint16_t)getchar();

                        break;
                    case TRAP_OUT:
                        /* TRAP OUT */
                        putc((char)reg[R_R0], stdout);
                        fflush(stdout);

                        break;
                    case TRAP_PUTS:

                    {
                            uint16_t* c = memory + reg[R_R0];
							if(validAdress(c, 0, ptr, 'R'))
							{
								while (*c)
								{
									putc((char)*c, stdout);
									++c;
									if(!validAdress(c, 0, ptr, 'R'))
									{
										running = 0;

										strcpy(OperationExecute, "\n Program abort memory out of bound");
										*c = 0;
									}
								}
								fflush(stdout);
							}
							else
							{
								running = 0;

strcpy(OperationExecute, "\n Program abort memory out of bound");
							}
                   }

                        break;
                    case TRAP_IN:
                        /* TRAP IN */
                        {
                            //printf("Enter a character: ");
                            strcpy(OperationExecute, "Entrer un character: ");
                            char c = getchar();
                            putc(c, stdout);
                            reg[R_R0] = (uint16_t)c;
                        }

                        break;
                    case TRAP_PUTSP:
                        /* TRAP PUTSP */
                    {

                            uint16_t* c = memory + reg[R_R0];
							if(validAdress(c, 0, ptr, 'R'))
							{
								while (*c)
								{
									char char1 = (*c) & 0xFF;
									putc(char1, stdout);
									char char2 = (*c) >> 8;

									if (char2) putc(char2, stdout);
									++c;
									if(!validAdress(c, 0, ptr, 'R'))
									{
										running = 0;

										strcpy(OperationExecute, "\n Program abort memory out of bound");
										*c = 0;
									}
								}
								fflush(stdout);
							}
							else
							{
								running = 0;

								strcpy(OperationExecute, "\n Program abort memory out of bound");
							}
                   }

                        break;
                    case TRAP_HALT:
                        /* TRAP HALT */
                        puts("\n HALT");
                        fflush(stdout);
                        running = 0;

                        break;
                }

                break;
            case OP_RES:
            case OP_RTI:
            default:
                /* BAD OPCODE */
                abort();

                break;
        }
    }



    ptr->VM.busy = 0;

    /* Shutdown */
    restore_input_buffering();


	 sem_post(&ptr->semVM);

    //liberer la console
    sem_post(&semC);

    sem_wait(&semnbThreadAELX);
	    nbThreadAELX--;
	sem_post(&semnbThreadAELX);

    pthread_exit(NULL);
}


//#######################################
//#
//# fonction utilisée pour le traitement  des transactions
//# ENTREE: Nom de fichier de transactions
//# SORTIE:
void* readTrans(char* nomFichier){
	FILE *f;
	char buffer[100];
	char *tok, *sp;

	pthread_t tid[1000];

	int i, nbTread =0;


	 int fifo_transaction_fd, client_fifo_fd;
    struct Info_FIFO_Transaction transaction;
    int read_res;
    char client_fifo[256];

	 //Creer la fifo //*-*-*-*-*-*-*-*-*-*-*-*-**-*-
    mkfifo(FIFO_TRANSACTIONS, 0777);

    fifo_transaction_fd = open(FIFO_TRANSACTIONS, O_RDONLY);

    if (fifo_transaction_fd == -1) {
        fprintf(stderr, "\tServer fifo failure\n");
        exit(EXIT_FAILURE);
    }

    sleep(5);

	do {
        read_res = read(fifo_transaction_fd, &transaction, sizeof(transaction));
        if (read_res > 0)
         {
      //Branchement selon le type de transaction
		switch(transaction.transaction[0]){
			case 'A':
			case 'a':{
				//Lancer l'ajout d'une vm de maniere concurente
				sem_wait(&semAdd);
            OperationAdd = transaction.transaction;
				pthread_create(&tid[nbTread++], NULL, addItem, NULL);
				sleep(0.7);
				break;
				}
			case 'E':
			case 'e':{

				struct Struct_REMOVE *ptr = (struct Struct_REMOVE*) malloc(sizeof(struct Struct_REMOVE));
				sem_wait(&semRemove);
            OperationRemove = transaction.transaction;
				//inserer les informations dans la structure
				ptr->noVM = extract(transaction.transaction);

				pthread_create(&tid[nbTread++], NULL, removeItem, ptr);
				sleep(0.5);
				break;
				}
			case 'L':
			case 'l':{

				struct Struct_Listage *ptr = (struct Struct_Listage*) malloc(sizeof(struct Struct_Listage));

				sem_wait(&semList);
            OperationList = transaction.transaction;
				ptr->start = extract(transaction.transaction);
				ptr->end = extract(transaction.transaction);



				pthread_create(&tid[nbTread++], NULL, listItems, ptr);
            sleep(05);
				break;
				}
			case 'X':
			case 'x':{
				int i = 4;
            int j = 0;
            transaction.transaction[0] = ' ';

				//creer la structure a passer en argument
				struct paramX *ptr = (struct paramX*) malloc(sizeof(struct paramX));

				sem_wait(&semExecute);
            OperationExecute= transaction.transaction;
            ptr->noVM = extract(transaction.transaction);

            while (transaction.transaction[i] != '\0')
            {
                 ptr->nomfich[j++] = transaction.transaction[i++];
            }


				pthread_create(&tid[nbTread++], NULL, executeFile, ptr);
				sleep(2);
				break;
				}
				default:
                    sprintf(transaction.transaction, "  ==========  Invalid transaction ==========") ;
		}

				sprintf(client_fifo, CLIENT_FIFO_NAME, transaction.pid_client);


            client_fifo_fd = open(client_fifo, O_WRONLY);

            if (client_fifo_fd != -1) {
                write(client_fifo_fd, &transaction, sizeof(transaction));
                close(client_fifo_fd);
            }
            sem_post(&semAdd);
            sem_post(&semRemove);
            sem_post(&semList);
            sem_post(&semExecute);
		}
		} while (read_res > 0);

	for(i=0; i<nbTread;i++) {
		pthread_join(tid[i], NULL);
	}
	close(fifo_transaction_fd);
    unlink(FIFO_TRANSACTIONS);
    exit(EXIT_SUCCESS);
	//Retour
	return NULL;
}
int extract(char *ptr)
{
    int param = 0;
    int i = 1;
    char listeChiffres [] = "123456789";
    char answer[]="0";

    while( i < strlen(ptr) && param == 0  )
    {
        for (int j = 0; j < sizeof(listeChiffres)-1; j++)
        {
            if(ptr[i] == listeChiffres[j])
            {
                answer[0] = listeChiffres[j];
                param = atoi(answer);
                ptr[i] = ' ';
                break;
            }
        }
        i++;
    }

    return param;

}
