//#################################################################
//# Auteur : 	Alexis Young, Charles Pellerin et Julien Boisvert
//#	Date :		Novembre 2023
//#################################################################

#include "gestionListeChaineeVMS.h"
#include "gestionVMS.h"

#define FIFO_NAME "/tmp/server_fifo"

//Pointeur de tête de liste
struct noeud* head;
//Pointeur de queue de liste pour ajout rapide
struct noeud* queue;

sem_t semH;
sem_t semQ;
sem_t semConsole;
// nombre de VM actives
int nbVM;


int main(int argc, char* argv[]){

    sem_init(&semH, 0, 1);
    sem_init(&semQ, 0, 1);
    sem_init(&semConsole, 0 , 1);

	//Initialisation des pointeurs
	head = NULL;
	queue = NULL;
	nbVM = 0;

	//"Nettoyage" de la fenêtre console
	//cls();

    // Vérifier si le fichier existe déjà, le supprimer
    unlink(FIFO_NAME);



    // Création de la FIFO du serveur
    if (mkfifo(FIFO_NAME, 0666) == -1) {
        perror("Erreur lors de la création de la FIFO du serveur");
        exit(EXIT_FAILURE);
    }


    // Vérifier les accès
    if (access(FIFO_NAME, F_OK) == -1) {
        perror("Erreur lors de l'accès au tube du serveur");
        exit(EXIT_FAILURE);
    }

    if (access(FIFO_NAME, R_OK) == -1) {
        perror("Erreur lors de l'accès au tube du serveur");
        exit(EXIT_FAILURE);
    }

    readTrans(FIFO_NAME);



    sem_destroy(&semQ);
    sem_destroy(&semH);
    sem_destroy(&semConsole);

	//Fin du programme
	exit( 0);
}

