#include "gestionListeChaineeVMS.h"
#include "server.h"

/* findItem finds and return a busy VM */
struct noeudVM* findItem(const int no){

    //Liste vide
    if ((head==NULL)&&(queue==NULL)) return NULL;

    //Pointeur de navigation
    while (head->VM.busy == 1){}
    head->VM.busy = 1;
    struct noeudVM * ptr = head;

    if(ptr->VM.noVM == no) return ptr; //Premier noeudVM

    /* Loop cycles trough the list to find the Vm whose number was given */
    while (ptr->suivant != NULL){
        /* Control of business */
        while (ptr->suivant->VM.busy == 1){}
        ptr->suivant->VM.busy = 1;
        ptr->VM.busy = 0;

        ptr = ptr->suivant;

        if (ptr->VM.noVM == no){
            return ptr;
        }
    }
    return NULL;

}

/* findPrev finds and returns a busy VM who is before the number (no) given */
struct noeudVM * findPrev(const int no){
    //Empty list
    if ((head == NULL)&&(queue == NULL)) return NULL;

    //navigation pointer
    while (head->VM.busy == 1){}
    head->VM.busy = 1;
    struct noeudVM* ptr = head;

    /* This loop should check and account for busy states while it loops through the VMs */
    while (ptr->suivant!=NULL){
        while (ptr->suivant->VM.busy == 1){}
        ptr->suivant->VM.busy = 1;
        if (ptr->suivant->VM.noVM==no){
            ptr->suivant->VM.busy = 0;
            return ptr; // Since the only use of the function findPrev is going to use the VM ptr I have left it's busy state as being 1
        }

        ptr->VM.busy = 0;
        ptr=ptr->suivant;
    }
    return NULL;
}

/* addItem adds a VM to the list as the last item in the chained list of VMs */
void* addItem(){

    /* Initial settings of the new VM */
    struct noeudVM* ni = (struct noeudVM*)malloc(sizeof(struct noeudVM));
    ni->VM.noVM = ++nbVM;
    ni->VM.busy = 0;
    ni->VM.ptrDebutVM = (unsigned short*)malloc(sizeof(unsigned short)*65536);

    /* Adding to an empty list */
    if ((head == NULL)&&(queue == NULL)){
        ni->suivant= NULL;  //if no other VM exist they can't also be busy so no checks needed
        queue = head = ni;
        return NULL;
    }

    /* Adding at the back of the list */
    while (queue->VM.busy == 1){} //wait for queue to be available
    queue->VM.busy = 1;

    struct noeudVM* tptr = queue;
    ni->suivant= NULL;
    queue = ni;
    tptr->suivant = ni;
    tptr->VM.busy = 0;
}

/* finds and removes a VM*/
void* removeItem(void *_noVM){
    int noVM = (int)_noVM;
    if ((head == NULL)&&(queue == NULL)) return NULL;

    struct noeudVM * ptr;
    struct noeudVM * tptr;
    struct noeudVM * optr;

    if(noVM==1){
        while (head->VM.busy == 1){}
        head->VM.busy = 1;
        ptr = head;
    }else{
        ptr = findPrev(noVM); //findPrev manages the busy states of the VM's and returns a busy VM
    }

    /* Now the VM before the one the remove have been found its time to delete it*/
    if (ptr != NULL){
        nbVM--;

        if ((head == ptr)&&(noVM == 1)){ //suppression tete
            if(head == queue){ //Only one element in the list
                free(ptr->VM.ptrDebutVM);
                free(ptr);
                queue = head = NULL;
                return NULL; //no need to set VM.Busy since there is no more elements in the list
            }
            while (ptr->suivant->VM.busy == 1){}
            ptr->suivant->VM.busy = 1;


            tptr = ptr->suivant;
            head = tptr;
            free(ptr->VM.ptrDebutVM);
            free(ptr);

            head->VM.busy = 0;
        }
        else if (queue == ptr->suivant){ // deletes queue
            while (queue->VM.busy == 1){}
            queue->VM.busy = 1;
            queue = ptr;
            free(ptr->suivant->VM.ptrDebutVM);
            free(ptr->suivant);
            ptr->suivant = NULL;
            ptr->VM.busy = 0;
            return NULL;
        }
        else{ //deletes a VM in the middle of the list
            while (ptr->suivant->VM.busy == 1){} // the VM to delete
            ptr->suivant->VM.busy = 1;
            optr = ptr->suivant;

            while (ptr->suivant->suivant->VM.busy == 1){} //VM after the one to delete
            ptr->suivant->suivant->VM.busy = 1;
            ptr->suivant = ptr->suivant->suivant; //sets the suivant of the VM before
            tptr = ptr->suivant;
            free(optr->VM.ptrDebutVM);
            free(optr);
        }
        while (1){
            tptr->VM.noVM--;
            if (tptr->suivant == NULL){
                tptr->VM.busy = 0;
                return NULL;
            }
            while (tptr->suivant->VM.busy == 1){}
            tptr->suivant->VM.busy = 1;
            tptr->VM.busy = 0;
            tptr = tptr->suivant;
        }
    }
}
void listItems(const int start,const int end){
    while (console == 1){}
    console = 1;
    printf("noVM   Busy?    Adresse Debut VM           \n");
    printf("===========================================\n");

    struct noeudVM * ptr = head;

    while (ptr != NULL){

        if ((ptr->VM.noVM >= start)&&(ptr->VM.noVM <= end)){
            printf("%d \t %d \t %p\n",
                   ptr->VM.noVM,
                   ptr->VM.busy,
                   ptr->VM.ptrDebutVM);
        }
        if (ptr->VM.noVM > end){
            ptr = NULL;
        }
        else{
            ptr = ptr->suivant;
        }
    }
    printf("===========================================\n");
    console = 0;
}
