//#########################################################
//#
//# Titre : 	TP2 (Utilitaires de l'application client - communication)
//#				LINUX Automne 23 SIF-1015 - Système d'exploitation
//#				Université du Québec à Trois-Rivières
//#
//# Auteur : 	Samuel Tessier
//#	Date :		Décembre 2023
//#
//# Langage : 	ANSI C on LINUX 
//#
//#########################################################

#include "client_helpers.h"

extern int serverFifoFd, clientFifoFd;
extern char clientFifo[100];
extern struct AppWindows *windows;

struct Info_FIFO_Transaction transaction;
int running = 1;

void openServerFifo() {
    serverFifoFd = open(SERVER_FIFO_NAME, O_WRONLY);
    if (serverFifoFd == -1) {
        fprintf(stderr, "Error server connection. \n");
        exit(EXIT_FAILURE);
    }
}

void initializeFIFO() {
    sprintf(clientFifo, CLIENT_FIFO_NAME, transaction.pid_client);
    if (mkfifo(clientFifo, 0777) == -1) {
        fprintf(stderr, "Error FIFO client : %s\n", clientFifo);
        exit(EXIT_FAILURE);
    }

    clientFifoFd = open(clientFifo, O_RDONLY);
    if (clientFifoFd == -1) {
       fprintf(stderr, "Error FIFO client : %s\n", clientFifo);
       exit(EXIT_FAILURE);
    }
}

void startServerHandler() {
    transaction.pid_client = getpid();
    pthread_t serverThread;

    pthread_create(&serverThread, NULL, (void* (*)(void*))readServerResult, NULL);
    pthread_detach(serverThread);
}

void readServerResult() {
    initializeFIFO();
    struct Info_FIFO_Transaction response;
    while (running) {
        if (read(clientFifoFd, &response, sizeof(struct Info_FIFO_Transaction)) > 0) {
            printServerResponse(response);
        }
    }
}

void readCommand() {
    openServerFifo();

    while (running) {
        printInstructions();
        
        wgetnstr(windows->transmission_window_ptr, transaction.transaction, sizeof(transaction.transaction) - 1);

        if (transaction.transaction[0] == 'q' || transaction.transaction[0] == 'Q') {
            running = 0;
            break;
        }

        processCommand();
    }
}

void processCommand() {
    write(serverFifoFd, &transaction, sizeof(struct Info_FIFO_Transaction));

    printInfoSent();

    sleep(1);
}
