//#########################################################
//#
//# Titre : 	TP2 (MAIN SERVEUR) LINUX Automne 23
//#				SIF-1015 - Système d'exploitation
//#				Université du Québec à Trois-Rivières
//#
//# Auteur : 	Samuel Tessier
//#	Date :		Décembre 2023
//#
//# Langage : 	ANSI C on LINUX 
//#
//#######################################

#include "gestionListeChaineeVMS.h"
#include "gestionVMS.h"

struct noeudVM* head;
struct noeudVM* queue;
int nbVM;
sem_t semH, semQ;
int *result;
pthread_mutex_t console_mutex;
int serverFifoFd, clientFifoFd;


void initialize() {
	head = NULL;
	queue = NULL;
	nbVM = 0;
	sem_init(&semH, 0, 1);
	sem_init(&semQ, 0, 1);
	pthread_mutex_init(&console_mutex, NULL);
	init_TPP();

	if (access(SERVER_FIFO_NAME, F_OK) == -1) {
		if (mkfifo(SERVER_FIFO_NAME, 0777) != 0) {
			fprintf(stderr, "Erreur de création de la FIFO serveur FIFO\n");
			exit(EXIT_FAILURE);
		}
	}
	serverFifoFd = open(SERVER_FIFO_NAME, O_RDONLY);
	if (serverFifoFd == -1) {
		fprintf(stderr, "Erreur d'ouverture de la FIFO serveur FIFO\n");
		exit(EXIT_FAILURE);
	}
	printf("Initialize terminé\n");
}

int main(int argc, char* argv[]) {
	initialize();
	struct Info_FIFO_Transaction transaction;
	char clientFifo[200];

	while (1) {
		if (read(serverFifoFd, &transaction, sizeof(struct Info_FIFO_Transaction)) > 0) {
			sprintf(clientFifo, CLIENT_FIFO_NAME, transaction.pid_client);
			clientFifoFd = open(clientFifo, O_WRONLY);
			
			if (clientFifoFd != -1) {
				readTrans(&transaction);
			}
		}
	}

	exit(0);
}

