//#########################################################
//# Titre : 	UTILITAIRES (MAIN) TP1 LINUX Automne 21
//#				SIF-1015 - Système d'exploitation
//#				Université du Québec à Trois-Rivières
//# Auteur : 	Francois Meunier
//# Modif  :   Schadrac
//#######################################

#include "gestionListeChaineeVMS.h"
#include "gestionVMS.h"

//Pointeur de tête de liste
struct noeud* tete;
//Pointeur de fin de liste pour ajout rapide
struct noeud* fin;
// nombre de VM actives
int nbVM;
//nombre de threads actifs A E L X
int nbThreadAELX;
// Creer 2 semaphores pour pointeur de tete et pointeur de fin
sem_t semT, semF;
// Semaphore ayant acces a nbVM, la console et nbThreadALX
sem_t semnbVM, semC, semnbThreadAELX;

//On a besoin de recuperer les info envoye par les clients et de les lires sans qu'un autre tread puisse y acceder,//-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*--*-//
//Alors, on cree un pointeur vers une zone de memoire ou on poura enregistrer ces donnes et y acceder en exclusion mutuelle
char* zoneMemoireOperationAdd;
char* zoneMemoireOperationRemove;
char* zoneMemoireOperationList;
char* zoneMemoireOperationExecute;

//Semaphores sur les nouveaux espace de memoire partage cree //-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*--*-//
sem_t semAdd, semRemove, semList, semExecute;

int main(int argc, char* argv[]){
	//Initialisation des pointeurs
	tete = NULL;
	fin = NULL;
	nbVM = 0;
	nbThreadAELX = 0;
	
//Initialisation des sémaphores
	sem_init(&semT, 0, 1);	
	sem_init(&semF, 0, 1);
	sem_init(&semnbVM, 0, 1);	
	sem_init(&semC, 0, 1);
	sem_init(&semnbThreadAELX, 0, 1);
	//Initialisation des sémaphores sur les nouvelles zones de memoires //-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*--*-//
	sem_init(&semAdd, 0, 1);
	sem_init(&semRemove, 0, 1);
	sem_init(&semList, 0, 1);
	sem_init(&semExecute, 0, 1);
	
	//"Nettoyage" de la fenêtre console
	//cls();
	printf("Ceci est un Server qui applique la concurrence:\n");
	printf("Notez que le temps d'attente general pour obtenir une reponse est varie entre 0.5 et 2 secondes!:\n");
printf("ATTENTION : L'interface client(console) doit etre assez grande pour afficher tout textes!\n");	
printf("\n");	
printf("Voici quelques exemples de comandes pour les tests:\n");	
printf("\tA\n");
printf("\tA\n");
printf("\tA\n");
printf("\tA\n");
printf("\tA\n");
printf("\tE 2\n");
printf("\tL 1-4\n");
printf("\tX 1 Mult-Numbers.olc3\n");	

	readTrans(argv[1]);

	//Supprimer les sémaphores
	sem_destroy(&semT);	
	sem_destroy(&semF);	
	sem_destroy(&semnbVM);	
	sem_destroy(&semC);	
	sem_destroy(&semnbThreadAELX);	
	//Suppression des sémaphores sur les nouvelles zones de memoires //-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*--*-//
	sem_destroy(&semAdd);
	sem_destroy(&semRemove);
	sem_destroy(&semList);
	sem_destroy(&semExecute);
	
	//Fin du programme
	exit( 0);
}

