//#########################################################
//#
//# Titre : 	Utilitaires Liste Chainee et CVS LINUX Automne 23
//#				SIF-1015 - Système d'exploitation
//#				Université du Québec à Trois-Rivières
//#
//# Auteur : 	Francois Meunier
//#	Date :		Septembre 2023
//#
//# Langage : 	ANSI C on LINUX 
//#
//#######################################

#include "gestionListeChaineeVMS.h"
#include "gestionVMS.h"

//Pointeur de tête de liste
extern struct noeudVM* head;
//Pointeur de queue de liste pour ajout rapide
extern struct noeudVM* queue;
// nombre de VM actives
extern int nbVM;
//nombre de threads actifs A E L X
extern int nbThreadAELX;

extern sem_t semH, semQ;

extern sem_t semC, semnbThreadAELX;


extern char* OperationAdd;
extern char* OperationRemove;
extern char* OperationList;
extern char* OperationExecute;


extern sem_t semAdd, semRemove, semList, semExecute;

struct noeudVM * findItem(const int no){

	sem_wait(&semH);
	sem_wait(&semQ);
	
	
	//La liste est vide 
	if ((head==NULL)&&(queue==NULL)) {

	sem_post(&semQ);
	sem_post(&semH);
	return NULL;}


	sem_wait(&head->semVM);

	struct noeudVM * ptr = head;

	sem_post(&semQ);
	sem_post(&semH);
	

	if(ptr->VM.noVM==no) // premier noeudVM
		return ptr; //retourner le noeud de tete verrouille
		

	if(ptr->suivant!=NULL){
		sem_wait(&(ptr->suivant->semVM)); // verrouille noeud suivant de ptr
	}else{
		sem_post(&(ptr->semVM)); // deverrouille noeud de tete 
	}
	
		//Tant qu'un item suivant existe
	while (ptr->suivant!=NULL){
		struct noeudVM* optr = ptr;
		//Déplacement du pointeur de navigation
		ptr=ptr->suivant;
		
		sem_post(&(optr->semVM)); 

		//Est-ce l'item recherché?
		if (ptr->VM.noVM==no){
			return ptr; // retourner le noeud verrouille
		}
		if(ptr->suivant!=NULL){
			sem_wait(&(ptr->suivant->semVM));
		}
		else{ // ptr->suivant==NULL no invalide
			sem_post(&(ptr->semVM)); // deverrouille dernier noeud verrouille
		}
	}
	//On retourne un pointeur NULL
	return NULL;
	}

//#######################################
//#
//# Recherche le PRÉDÉCESSEUR d'un item dans la liste chaînée
//# ENTREE: Numéro de la ligne a supprimer
//# RETOUR:	Le pointeur vers le prédécesseur est retourné		
//# 		Retourne NULL dans le cas où l'item est introuvable
//#
struct noeudVM * findPrev(const int no){

	sem_wait(&semH);
	sem_wait(&semQ);
	
	
	//La liste est vide 
	if ((head==NULL)&&(queue==NULL)){
	//si la liste est vide, on libere la tete et fin de liste et on retourne null
	sem_post(&semQ);
	sem_post(&semH);
	return NULL;
}

	sem_wait(&head->semVM);

	struct noeudVM * ptr = head;

	sem_post(&semQ);
	sem_post(&semH);
	

	while (ptr->suivant!=NULL){

		if (ptr->suivant->VM.noVM==no){
			//On retourne un pointeur sur l'item précédent
			sem_post(&ptr->semVM);
			return ptr;
		}
		//Déplacement du pointeur de navigation(avancer!))
		struct noeudVM* optr = ptr;
		ptr=ptr->suivant;
		sem_post(&optr->semVM);
		
															
		if(ptr->suivant != NULL){
			sem_wait(&ptr->suivant->semVM);
		}
	}
	//On retourne un pointeur NULL
	return NULL;
}

//#####################################################
//# Ajoute un item a la fin de la liste chaînée de VM
//# ENTREE: 
//#	RETOUR:  
void addItem(void * ptr)
{	
	sem_wait(&semnbThreadAELX);
	    nbThreadAELX++;
	sem_post(&semnbThreadAELX);
	
	
	//Création de l'enregistrement en mémoire
	struct noeudVM* ni = (struct noeudVM*)malloc(sizeof(struct noeudVM));
	sem_init(&ni->semVM, 0, 1);

	//Affectation des valeurs des champs
	sem_wait(&semnbThreadAELX);	
	
	ni->VM.noVM = ++nbVM;

			 strcpy(OperationAdd,"************ Une machine virtuelle a ete ajoutee!************\n");
	sem_post(&semnbThreadAELX);

 	ni->VM.busy	= 0;
	//printf("\n busy=%d", ni->VM.busy);
	ni->VM.ptrDebutVM	= (unsigned short*)malloc(sizeof(unsigned short)*65536);
	
	sem_wait(&semH);
	sem_wait(&semQ);	
	
	if ((head == NULL) && (queue == NULL)) //liste vide
	{       
		ni->suivant= NULL;
		queue = head = ni;
	  
	  	sem_post(&semQ);
	  	sem_post(&semH);

		sem_wait(&semnbThreadAELX);
	    nbThreadAELX--;
		sem_post(&semnbThreadAELX);
	  
	  return;
	}
	
	sem_post(&semH);
	sem_wait(&queue->semVM);
	struct noeudVM* tptr = queue;	
	
	ni->suivant= NULL;
	
	queue = ni;
	
	sem_post(&semQ);
	
	tptr->suivant = ni;
	
	//sem_post(&ni->semVM);
	sem_post(&tptr->semVM); // deverrouille le noeud avant le noeud de queue
	
	sem_wait(&semnbThreadAELX);
	    nbThreadAELX--;
	sem_post(&semnbThreadAELX);
	
	

}

//#######################################
//# Retire un item de la liste chaînée
//# ENTREE: noVM: numéro du noeud a retirer 
void removeItem(struct Struct_REMOVE* param)
{	
	int noVM;
	
	noVM = param->noVM;
	free(param);	
	
	if(noVM == 0 || noVM > nbVM)
	{		
		strcpy(OperationRemove,"--------------- La machine virtuelle que vous souhaité retirer est inexistante ---------------");
		return;	
	}
	struct noeudVM * ptr;
	struct noeudVM * tptr;
	struct noeudVM * optr;	
	
    // Attendre la terminaison des threads A E L et X  
    while(1) 
    {     
        sem_wait(&semnbThreadAELX);
	
        if(nbThreadAELX == 0)
        {
            sem_wait(&semH);
            
            sem_wait(&semQ);
            
            sem_post(&semnbThreadAELX);
            break;
        }
        sem_post(&semnbThreadAELX);	
    }	
    
	    
	// Verification sommaire
	if(((noVM<1)|| (head == NULL)) && (queue == NULL))
	{
		
	  	sem_post(&semQ);
	  	sem_post(&semH);
	  	
	  return;
	}
	
	//Pointeur de recherche
	if(noVM==1)
	{
		ptr = head;
		
	}
	else
	{

		sem_post(&semQ);
	  	sem_post(&semH);	  	
		

		ptr =findPrev(noVM);
		
		sem_wait(&semH);	    
	   	sem_wait(&semQ);
		
	}
	//L'item a été trouvé
	if (ptr!=NULL)
	{		
		sem_wait(&semnbThreadAELX);
		nbVM--;

		sprintf(OperationRemove, "-------------------- La machine virtuelle a ete suprime! --------------------\n------------------------ Il reste %d machine virtuelle(s) ------------------------\n", nbVM);
		sem_post(&semnbThreadAELX);


		if((head == ptr) && (noVM==1))
		{
			if(head==queue)
			{
				sem_destroy(&ptr->semVM);
				free(ptr->VM.ptrDebutVM);
				free(ptr);
				queue = head = NULL;
				sem_post(&semQ);
				sem_post(&semH);
				
				return;
			}
			tptr = ptr->suivant;
			head = tptr;
			sem_destroy(&ptr->semVM);	
			free(ptr->VM.ptrDebutVM);
			free(ptr);
			sem_post(&semQ);
	       	sem_post(&semH);
		}
		else if (queue==ptr->suivant)
		{
			queue=ptr;
			sem_destroy(&ptr->suivant->semVM);
			free(ptr->suivant->VM.ptrDebutVM);
			free(ptr->suivant);
			ptr->suivant=NULL;
			sem_post(&semQ);
			sem_post(&semH);
			
			return;
		}
		else
		{
			optr = ptr->suivant;	
			ptr->suivant = ptr->suivant->suivant;
			tptr = ptr->suivant;
			sem_destroy(&optr->semVM);
			free(optr->VM.ptrDebutVM);
			free(optr);
			sem_post(&semQ);
			sem_post(&semH);			
		}		
		
		sem_wait(&tptr->semVM);
		while (tptr!=NULL)
		{


			
			tptr->VM.noVM--;

			sem_post(&tptr->semVM);
			
			tptr=tptr->suivant;
			
			if(tptr != NULL)
				sem_wait(&tptr->semVM);					
		}	
		
	}		
	
}

//#######################################
//#
//# Affiche les items dont le numéro séquentiel est compris dans une plage
//#
void listItems(struct Struct_Listage* param)
{ 
	int start, end;
	
	start = param->start;
	end = param->end;
	free(param);
	
	sem_wait(&semnbThreadAELX);
	    nbThreadAELX++;
	sem_post(&semnbThreadAELX);	
		
	sem_wait(&semH);	
	sem_wait(&semQ);	
	sem_wait(&semC);
	

	
	strcpy(OperationList, "    noVM    Busy?		Adresse Debut VM                       \n");
	strcat(OperationList, "  ============================================================\n");
	
	
	
	
	if(head != NULL){ // si liste non vide
	    sem_wait(&head->semVM);
	    sem_post(&semQ);
	    sem_post(&semH);
	}
	else{
	    sem_post(&semC);
	    sem_post(&semQ);
	    sem_post(&semH);
	    sem_wait(&semnbThreadAELX);
		nbThreadAELX--;
	    sem_post(&semnbThreadAELX);
	    return;
	}	
	
	struct noeudVM * ptr = head; //premier element

	while (ptr!=NULL)
	{//L'item a un numéro séquentiel dans l'interval défini
		if ((ptr->VM.noVM>=start)&&(ptr->VM.noVM<=end))
		{
				char data []="                     ";			
			sprintf(data,"\t%d \t %d \t %p\n",ptr->VM.noVM, ptr->VM.busy, ptr->VM.ptrDebutVM);			
			strcat(OperationList, data);
		}
		
		if (ptr->VM.noVM>end)
		{

			sem_post(&ptr->semVM);
			ptr=NULL;
		}
		
		else
		{
			
			if(ptr->suivant != NULL)
			{
				sem_wait(&ptr->suivant->semVM);
				struct noeudVM* optr;
				optr = ptr;
				ptr = ptr->suivant;
				sem_post(&optr->semVM);
			}
			
			else
			{
				sem_post(&ptr->semVM);
				ptr = NULL;
			}		
		}

	}

	//Affichage des pieds de colonnes
	strcat(OperationList, "  ============================================================\n\n");
	sem_post(&semC);
	sem_wait(&semnbThreadAELX);
	    nbThreadAELX--;
	sem_post(&semnbThreadAELX);
	
}
