//#########################################################
//#
//# Titre : 	UTILITAIRES (MAIN) TP1 LINUX Automne 21
//#				SIF-1015 - Système d'exploitation
//#				Université du Québec à Trois-Rivières
//#
//# Auteur : 	Luc Allaire, Julien Desrosiers et Janik Lesage
//#	Date :		Automne 2023
//#
//# Langage : 	ANSI C on LINUX 
//#
//#######################################

#include "gestionListeChaineeVMS.h"
#include "gestionVMS.h"
#include <sys/types.h>
#include <sys/stat.h>

//Pointeur de tête de liste
struct noeud *head;
//Pointeur de queue de liste pour ajout rapide
struct noeud *queue;
// nombre de VM actives
int nbVM;

// Semaphores
sem_t semHead;
sem_t semQueue;
sem_t semNbVM;
sem_t semConsole;

char * FIFO_TRANSACTIONS = "/tmp/transFIFO";


int main(int argc, char *argv[]) {

    // Initialisation des semaphores
    sem_init(&semHead, 0, 1);
    sem_init(&semQueue, 0, 1);
    sem_init(&semNbVM, 0, 1);
    sem_init(&semConsole, 0, 1);

    //Initialisation des pointeurs
    head = NULL;
    queue = NULL;
    nbVM = 0;

    // Prep la fifo

    // Si le fichier de transactions existe, on le supprime
    if (access(FIFO_TRANSACTIONS, F_OK) != -1) {
        remove(FIFO_TRANSACTIONS);
    }

    // Fifo pour les transactions
    if (mkfifo(FIFO_TRANSACTIONS, 0777) == -1) {
        perror("mkfifo");
        exit(1);
    }

    // Check if fifo is created
    if (access(FIFO_TRANSACTIONS, F_OK) != -1) {
        printf("FIFO_TRANSACTIONS created\n");
    } else {
        printf("FIFO_TRANSACTIONS not created\n");
    }

    // Check for read access
    if (access(FIFO_TRANSACTIONS, R_OK) != -1) {
        printf("FIFO_TRANSACTIONS read access\n");
    } else {
        printf("FIFO_TRANSACTIONS no read access\n");
    }

    // If the current directory doesn't contain the backend folder, we change the current directory
    if (access("backend", F_OK) == -1) {
        // We are in the build folder, we need to go back to the root folder (2 times)
        chdir("..");
        chdir("..");
    }

    readTrans();

    // Stop the program when the python front is closed
    exit(0);
}

