#include "tp2Client.h"

int serveurFifo, clientFifo;
struct Info_FIFO_Transaction msgSend;
struct Info_FIFO_Feedback msgReceive;
char clientFifoName[256];
pthread_t thread1;

char test[20];
WINDOW * send;
WINDOW * receive;

int main()
{
    //determine le type de terminal et init ncurse
    initscr();
    start_color();
    
    init_pair(1, COLOR_RED, COLOR_BLACK);
    //crée les windows
    send = newwin(15,75,0,0);
    receive = newwin(15,75,0,send->_maxx + 1);
    draw_borders(send);
    draw_borders(receive);
    wmove(send,3,2);
    mvwprintw(send, 1, 1, "TRANSMISSION");
    wattron(receive, COLOR_PAIR(1));
    mvwprintw(receive, 1, 1, "RECEPTION");
    wattroff(receive, COLOR_PAIR(1));
    wrefresh(send);
    wrefresh(receive);

    //set le nom du client à client_pid
    snprintf(clientFifoName, sizeof(clientFifoName), "client_%d", getpid());

    //connection à la fifo du serveur en write only
    serveurFifo = open("./fifo_transaction", O_WRONLY);
    if (serveurFifo == -1)
    {
        printf("Erreur d'ouverture du fifo serveur\n");
        endwin();
        exit(1);
    }

    //set le clientPid dans le message pour que le serveur sache qui a demandé pour le retour
    msgSend.pid_client = getpid();

    //création de la fifo du client pour recevoir les résultats
    if(mkfifo(clientFifoName, 0666) == -1)
    {
        printf("Erreur de creation du fifo client\n");
        endwin();
        exit(1);
    }

    //creation du thread pour se connecter à la fifo créer et recevoir les résultats
    pthread_create(&thread1, NULL, FeedBack,(void *) NULL);

    while (1)
    {
        //move le curseur dans la fenètre transmisson à la bonne place
        wmove(send,3,3);
        //reset le message
        msgSend.transaction == "";
        wscanw(send,"%[^\t\n]s", msgSend.transaction);
        if(*msgSend.transaction == 'q' | *msgSend.transaction == 'Q')
        {
            unlink(clientFifoName);
            break;
        }
        mvwprintw(send,2,2,"%s a été envoyer au serveur\n", msgSend.transaction);
        wmove(send,3,2);
        wclrtoeol(send);
        wrefresh(send);

        write(serveurFifo, &msgSend, sizeof(struct Info_FIFO_Transaction));
        sleep(1);
    }
    endwin();
    return 0;
}

void * FeedBack()
{
    clientFifo = open(clientFifoName, O_RDONLY);
    if (clientFifo == -1)
    {
        printf("Erreur d'ouverture du fifo client\n");
        endwin();
        exit(1);
    }

    int row = 3;
    while(1)
    {
        read(clientFifo, &msgReceive, sizeof(struct Info_FIFO_Feedback));
        wattron(receive, COLOR_PAIR(1));
        mvwaddstr(receive, row ,2,msgReceive.feedback);
        wattroff(receive, COLOR_PAIR(1));
        wrefresh(receive);

        row++;
        if(row + 1 >= getmaxy(receive)) {
            wclear(receive);
            draw_borders(receive);
            wattron(receive, COLOR_PAIR(1));
            mvwprintw(receive, 1, 1, "RECEPTION");
            wattroff(receive, COLOR_PAIR(1));
            row = 3;
        }
    }
    return NULL;
}

void draw_borders(WINDOW *screen) 
{ 
    int x, y, i; getmaxyx(screen, y, x); 
    // 4 corners 
    mvwprintw(screen, 0, 0, "+"); 
    mvwprintw(screen, y - 1, 0, "+"); 
    mvwprintw(screen, 0, x - 1, "+"); 
    mvwprintw(screen, y - 1, x - 1, "+"); 
    // sides 
    for (i = 1; i < (y - 1); i++) 
    { 
        mvwprintw(screen, i, 0, "|"); 
        mvwprintw(screen, i, x - 1, "|"); 
    } 
    // top and bottom 
    for (i = 1; i < (x - 1); i++) 
    { 
        mvwprintw(screen, 0, i, "-"); 
        mvwprintw(screen, y - 1, i, "-"); 
    } 
}